<template>
  <div id="group-table">
    <p
      v-if="groups.length < 1"
      class="empty-table"
    >
      No groups
    </p>
    <table v-else>
      <thead>
        <tr>
          <th>Name</th>
          <th>Goal</th>
          <th>Actions</th>
        </tr>
      </thead>
      <tbody>
        <tr
          :key="group.id"
          v-for="group in groups"
        >
          <td v-if="editing === group.id">
            <input
              type="text"
              v-model="group.name"
            >
          </td>
          <td v-else>{{group.name}}</td>
          <td v-if="editing === group.id">
            <input
              type="text"
              v-model="group.goal"
            >
          </td>
          <td v-else>{{group.goal}}</td>
          <td v-if="editing === group.id">
            <button @click="editGroup(group)">Save</button>
            <button
              class="muted-button"
              @click="cancelEdit(group)"
            >Cancel</button>
          </td>
          <td v-else>
            <button @click="editMode(group)">Edit</button>
            <button @click="$emit('delete:group', group.id)">Delete</button>
          </td>

        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
export default {
  name: 'group-table',
  props: {
    groups: Array,
  },
  data() {
    return {
      editing: null,
    }
  },
  methods: {
    editMode(group) {
      this.cachedGroup = Object.assign({}, group)
      this.editing = group.id
    },

    cancelEdit(group) {
      Object.assign(group, this.cachedGroup)
      this.editing = null;
    },
 
    editGroup(group) {
      if (group.name === '' || group.goal === '') return
      this.$emit('edit:group', group.id, group)
      this.editing = null
    }
  }
}
</script>

<style scoped>
button {
  margin: 0 0.5rem 0 0;
}

input {
  margin: 0;
}

.empty-table {
  text-align: center;
}
</style>
